// Advanced Filter
// Rojohound
// PS 2.0
// White preserving filter.


//#PARAM float newr 255 : red : Red value.
//#PARAM float newg 255 : green : Green value.
//#PARAM float newb 255 : blue : Blue value.
//#PARAM percent factor 1: Intensity: Strength of effect.

float newr;
float newb;
float newg;
float factor;

// Foreground texture
texture ForegroundTexture;

// Background texture
//texture BackgroundTexture;

// Foreground sampler
sampler2D foreground = sampler_state {
    Texture = (ForegroundTexture);
    MinFilter = Point;
    MagFilter = Point;
    MipFilter = Point;
};


// Effect function
float4 EffectProcess( float2 Tex : TEXCOORD0 ) : COLOR0
{
	float4 front = tex2D(foreground, Tex.xy);
	front.rgb /= front.a;
	float light = min(min(front.r,front.g),front.b);
	float value = ((front.r + front.g + front.b)/3 - light)*3/255;
	front.r = front.r*(1-factor) +(value*newr+light)*factor;
	front.b = front.b*(1-factor) +(value*newb+light)*factor;
	front.g = front.g*(1-factor) +(value*newg+light)*factor;
		
	front.rgb *= front.a;
	return front;
}

// ConstructEffect
technique ConstructEffect
{
    pass p0
    {
        VertexShader = null;
        PixelShader = compile ps_2_0 EffectProcess();
    }
}
