// NuovoFill
// Davioware
// PS 2.0
// Fill opaque areas with a solid color to a certain percent,with selectable blending mode. (linearly interpolated)

//#PARAM float fRed 255 : Red : Red Fill 0-255.
//#PARAM float fGreen 255 : Green : Green Fill 0-255.
//#PARAM float fBlue 255 : Blue : Blue Fill 0-255.
//#PARAM percent intensity 1 : Intensity : Intensity of blend.
//#PARAM float mode 1 : Blend mode : 1 = raw color , 2 = additive, 3 = multiply


// Parameter variables
float fRed;
float fGreen;
float fBlue;
float frameDelay;
float intensity;
float mode;

float frameCounter;

// Foreground texture
texture ForegroundTexture;

// Foreground sampler
sampler2D foreground = sampler_state {
    Texture = (ForegroundTexture);
    MinFilter = Point;
    MagFilter = Point;
    MipFilter = Point;
};


// Effect function
float4 EffectProcess( float2 Tex : TEXCOORD0 ) : COLOR0
{
 float4 Color;
    
	Color = tex2D(foreground, Tex.xy);
	
	if((int)mode==1)
	{	
	Color.rgb /= Color.a;
	Color.r  = lerp(Color.r,(fRed/255),intensity);
	Color.g = lerp(Color.g,(fGreen/255),intensity);
	Color.b = lerp(Color.b,(fBlue/255),intensity);
	Color.rgb *= Color.a;
	}
	else if((int)mode==2)
	{
	Color.rgb /= Color.a;
	Color.r  = lerp(Color.r,(fRed/255)+Color.r,intensity);
	Color.g = lerp(Color.g,(fGreen/255)+Color.g,intensity);
	Color.b = lerp(Color.b,(fBlue/255)+Color.b,intensity);
	Color.rgb *= Color.a;
	}
	else if((int)mode==3)
	{
		Color.rgb /= Color.a;
	Color.r  = lerp(Color.r,(fRed/255)*Color.r,intensity);
	Color.g = lerp(Color.g,(fGreen/255)*Color.g,intensity);
	Color.b = lerp(Color.b,(fBlue/255)*Color.b,intensity);
	Color.rgb *= Color.a;
	}
		   
	return Color;
}

// ConstructEffect
technique ConstructEffect
{
    pass p0
    {
        VertexShader = null;
        PixelShader = compile ps_2_0 EffectProcess();
    }
}
